package org.jboss.as.quickstarts.mdb;

import java.util.logging.Logger;

import org.jboss.as.quickstarts.servlet.MessageWrapper;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;

@MessageDriven(name = "HelloWorldQTopicMDB", activationConfig = {
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "topic/HELLOWORLDMDBTopic"),
		@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge")
})
public class HelloWorldTopicMDB implements MessageListener {

	private final static Logger LOGGER = Logger.getLogger(HelloWorldTopicMDB.class.toString());

	public void onMessage(Message rcvMessage) {
		try {
			if (rcvMessage instanceof TextMessage) {
				TextMessage msg = (TextMessage) rcvMessage;
				LOGGER.info("(" + this.toString() +") Received Message from topic: " + msg.getText());
			} else if (rcvMessage instanceof ObjectMessage) {
				ObjectMessage msg = (ObjectMessage) rcvMessage;
				MessageWrapper wraper = (MessageWrapper) msg.getObject();
				LOGGER.info("(" + this.toString() +") Received Message from topic: " + wraper.toString());
			} else {
				LOGGER.warning("Message of wrong type: " + rcvMessage.getClass().getName());
			}
		} catch (JMSException e) {
			throw new RuntimeException(e);
		}
	}
}
